from portal.database.models import User, Submission, Role, Course, Group


def assert_user(expected: User, actual: dict):
    assert expected.id == actual['id']
    assert expected.uco == actual['uco']
    assert expected.email == actual['email']
    assert expected.username == actual['username']
    assert expected.name == actual['name']
    assert expected.is_admin == actual['is_admin']


def compare_user(expected: User, actual: dict):
    return expected.id == actual['id'] and expected.uco == actual['uco'] and expected.email == actual['email']


def assert_user_in(user_list: list, user: dict):
    for u in user_list:
        if compare_user(u, user):
            return True
    return False


def assert_submission(expected: Submission, actual: dict):
    assert expected.id == actual['id']
    assert expected.state.name == actual['state']
    assert expected.project.course_id == actual['project']["course"]["id"]
    assert expected.scheduled_for == actual['scheduled_for']
    assert expected.project_id == actual['project']['id']


def assert_role(expected: Role, actual: dict):
    assert expected.id == actual['id']
    assert expected.name == actual['name']
    assert expected.description == actual['description']
    assert expected.course_id == actual['course']['id']


def assert_course(expected: Course, actual: dict):
    assert expected.id == actual['id']
    assert expected.name == actual['name']
    assert expected.codename == actual['codename']


def compare_course(expected: Course, actual: dict):
    return expected.id == actual['id'] and expected.codename == actual['codename']


def assert_course_in(course_list: list, course: dict):
    for c in course_list:
        if compare_course(c, course):
            return True
    return False


def assert_group(expected: Group, actual: dict):
    assert expected.id == actual['id']
    assert expected.name == actual['name']
    assert expected.course_id == actual['course']['id']
